GET /v2/locations
Retrieve a list of IBM Cloud locations where you can work with the Schematics objects.
<h3>Authorization</h3>
Schematics support generic authorization for its resources.
For more information, about Schematics access and permissions,
see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).
Request
Response
200 - Successfully listed all the locations.
locations
array
The list of locations.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
GET /v1/resource_groups
Retrieve a list of IBM Cloud resource groups that your account has access to.
<h3>Authorization</h3>
Schematics support generic authorization for its resources.
For more information, about Schematics access and permissions,
see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).
Request
Response
200 - Successfully returned resource groups information.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Get Schematics API information
GET /v1/version
Retrieve detailed information about the IBM Cloud Schematics API version and the version of the provider plug-ins that the API uses.
Request
Response
200 - Successfully returned version information.
builddate
string
The date when the API version was built.
buildno
string
The build number that the API is based on.
commitsha
string
The SHA value for the Git commit that represents the latest version of the API.
helm_provider_version
string
The Terraform Helm provider version that is used when you install Helm charts with Schematics.
helm_version
string
The Helm version that is used when you install Helm charts with Schematics.
supported_template_types
object
Supported template types
terraform_provider_version
string
The version of the IBM Cloud Terraform provider plug-in that is used when you apply Terraform templates with Schematics.
terraform_version
string
The Terraform version that is used when you apply Terraform templates with Schematics.
<h3>Authorization</h3>
Schematics support generic authorization for its resources.
For more information, about Schematics access and permissions,
see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).">
List workspaces
GET /v1/workspaces
Retrieve a list of Schematics workspaces from your IBM Cloud account that you have access to. The list of workspaces that is returned depends on the API endpoint that you use. For example, if you use an API endpoint for a geography, such as North America, only workspaces that are created in `us-south` or `us-east` are returned.
For more information about supported API endpoints, see API endpoints.
<h3>Authorization</h3>
Schematics support generic authorization for its resources.
For more information, about Schematics access and permissions,
see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).
Auditing
Calling this method generates the following auditing event.
schematics.workspace.list
Request
Path Parameters
Query Parameters
offset
integer
The starting position of the item in the list of items. For example, if you have three workspaces in your account, the first workspace is assigned position number 0, the second workspace is assigned position number 1, and so forth. If you have 6 workspaces and you want to list the details for workspaces `2-6`, enter 1. To limit the number of workspaces that is returned, use the `limit` option in addition to the `offset` option. Negative numbers are not supported and are ignored.
limit
integer
The maximum number of items that you want to list. The number must be a positive integer between 1 and 2000. If no value is provided, 100 is used by default.
profile
string
Level of details returned by the get method
resource_group
string
The resource group (by default, fetch from all resource groups) name or ID
Response
200 - Successfully listed the workspaces that you have access to.
count
integer
The number of workspaces in the IBM Cloud account that you have access to and that matched your search criteria.
limit
integer
The `limit` value that you set in your API request and that represents the maximum number of workspaces that you wanted to list.
offset
integer
The `offset` value that you set in your API request. The offset value represents the position number of the workspace from which you wanted to start listing your workspaces.
workspaces
array
The list of workspaces that was included in your API response.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
If you use the API endpoint for a geography and not a specific location, such as North America, you can specify the location in your API request body.
If you do not specify the location in the request body, Schematics determines your workspace location based on availability.
If you use an API endpoint for a specific location, such as Frankfurt, the location that you enter in your API request body must match your API endpoint.
You also have the option to not specify a location in your API request body if you use a location-specific API endpoint.
Getting IAM access token :-
-
Before you create Schematics workspace, you need to create the IAM access token for your IBM Cloud Account.
-
To create IAM access token, use `export IBMCLOUD_API_KEY=<ibmcloud_api_key>` and execute `curl -X POST "https://iam.cloud.ibm.com/identity/token" -H "Content-Type= application/x-www-form-urlencoded" -d "grant_type=urn:ibm:params:oauth:grant-type:apikey&apikey=$IBMCLOUD_API_KEY" -u bx:bx`. For more information, about creating IAM access token and API Docs, see IAM access token and Create API key.
-
You can set the environment values `export ACCESS_TOKEN=<access_token>` and `export REFRESH_TOKEN=<refresh_token>`.
-
You can use the obtained IAM access token in create workspace `curl` command.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.">
Create a workspace
POST /v1/workspaces
Create an IBM Cloud Schematics workspace that points to the source repository where your Terraform template or the IBM Cloud software template is stored. You can decide to create your workspace without connecting it to a GitHub or GitLab repository. Your workspace is then created with a Draft state. To later connect your workspace to a GitHub or GitLab repository, you must use the `PUT /v1/workspaces/{id}` API to update the workspace or use the `/v1/workspaces/{id}/templates/{template_id}/template_repo_upload` API to upload a TAR file instead.
Getting API endpoint:-
-
The Schematics API endpoint that you use to create the workspace determines where your Schematics actions run and your data is stored. See API endpoints for more information.
-
If you use the API endpoint for a geography and not a specific location, such as North America, you can specify the location in your API request body.
-
If you do not specify the location in the request body, Schematics determines your workspace location based on availability.
-
If you use an API endpoint for a specific location, such as Frankfurt, the location that you enter in your API request body must match your API endpoint.
-
You also have the option to not specify a location in your API request body if you use a location-specific API endpoint.
Getting IAM access token :-
-
Before you create Schematics workspace, you need to create the IAM access token for your IBM Cloud Account.
-
To create IAM access token, use `export IBMCLOUD_API_KEY=<ibmcloud_api_key>` and execute `curl -X POST "https://iam.cloud.ibm.com/identity/token" -H "Content-Type= application/x-www-form-urlencoded" -d "grant_type=urn:ibm:params:oauth:grant-type:apikey&apikey=$IBMCLOUD_API_KEY" -u bx:bx`. For more information, about creating IAM access token and API Docs, see IAM access token and Create API key.
-
You can set the environment values `export ACCESS_TOKEN=<access_token>` and `export REFRESH_TOKEN=<refresh_token>`.
-
You can use the obtained IAM access token in create workspace `curl` command.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.create
Request
Request Body
WorkspaceCreateRequest
Input parameter to create the IBM Cloud Schematics workspace.
applied_shareddata_ids
array
List of applied shared dataset ID.
catalog_ref
CatalogRef
Information about the software template that you chose from the IBM Cloud catalog. This information is returned for IBM Cloud catalog offerings only.
dry_run
boolean
Dry run
owning_account
string
Owning account ID of the catalog.
item_icon_url
string
The URL to the icon of the software template in the IBM Cloud catalog.
item_id
string
The ID of the software template that you chose to install from the IBM Cloud catalog. This software is provisioned with Schematics.
item_name
string
The name of the software that you chose to install from the IBM Cloud catalog.
item_readme_url
string
The URL to the readme file of the software template in the IBM Cloud catalog.
item_url
string
The URL to the software template in the IBM Cloud catalog.
launch_url
string
The URL to the dashboard to access your software.
offering_version
string
The version of the software template that you chose to install from the IBM Cloud catalog.
service_extensions
array
Service Extensions
dependencies
Dependencies
Workspace dependencies
parents
array
List of workspace parents CRN identifiers
children
array
List of workspace children CRN identifiers
description
string
The description of the workspace.
location
string
The location where you want to create your Schematics workspace and run the Schematics jobs. The location that you enter must match the API endpoint that you use. For example, if you use the Frankfurt API endpoint, you must specify `eu-de` as your location. If you use an API endpoint for a geography and you do not specify a location, Schematics determines the location based on availability.
name
string
The name of your workspace. The name can be up to 128 characters long and can include alphanumeric characters, spaces, dashes, and underscores. When you create a workspace for your own Terraform template, consider including the microservice component that you set up with your Terraform template and the IBM Cloud environment where you want to deploy your resources in your name.
resource_group
string
The ID of the resource group where you want to provision the workspace.
shared_data
SharedTargetData
Information about the Target used by the templates originating from the IBM Cloud catalog offerings. This information is not relevant for workspace created using your own Terraform template.
cluster_created_on
string
Cluster created on.
cluster_id
string
The ID of the cluster where you want to provision the resources of all IBM Cloud catalog templates that are included in the catalog offering.
cluster_name
string
The cluster name.
cluster_type
string
The cluster type.
entitlement_keys
array
The entitlement key that you want to use to install IBM Cloud entitled software.
namespace
string
The Kubernetes namespace or OpenShift project where the resources of all IBM Cloud catalog templates that are included in the catalog offering are deployed into.
region
string
The IBM Cloud region that you want to use for the resources of all IBM Cloud catalog templates that are included in the catalog offering.
resource_group_id
string
The ID of the resource group that you want to use for the resources of all IBM Cloud catalog templates that are included in the catalog offering.
worker_count
integer
The cluster worker count.
worker_machine_type
string
The cluster worker type.
tags
array
A list of tags that are associated with the workspace.
template_data
array
Input data for the Template
template_ref
string
Workspace template ref
template_repo
TemplateRepoRequest
Input variables for the Template repoository, while creating a workspace
branch
string
The repository branch
release
string
The repository release.
repo_sha_value
string
The repository SHA value.
repo_url
string
The repository URL.
url
string
The source URL.
skip_submodules_checkout
boolean
Set this variable to checkout git sub-modules.
type
array
List of Workspace type
workspace_status
WorkspaceStatusRequest
WorkspaceStatusRequest -
frozen
boolean
If set to true, the workspace is frozen and changes to the workspace are disabled.
frozen_at
string
The timestamp when the workspace was frozen.
frozen_by
string
The user ID that froze the workspace.
locked
boolean
If set to true, the workspace is locked and disabled for changes.
locked_by
string
The user ID that initiated a resource-related job, such as applying or destroying resources, that locked the workspace.
locked_time
string
The timestamp when the workspace was locked.
agent_id
string
agent id which is binded to with the workspace.
settings
array
Input settings to be applied to the workspace, for example, `job_timeout_override`
Path Parameters
Query Parameters
Response
201 - Successfully created the workspace in IBM Cloud Schematics. Your resources are not provisioned until you use the `POST /workspaces/{id}/apply` API.
applied_shareddata_ids
array
List of applied shared dataset ID.
catalog_ref
CatalogRef
Information about the software template that you chose from the IBM Cloud catalog. This information is returned for IBM Cloud catalog offerings only.
created_at
string
The timestamp when the workspace was created.
created_by
string
The user ID that created the workspace.
crn
string
The workspace CRN.
dependencies
Dependencies
Workspace dependencies
description
string
The description of the workspace.
id
string
The unique identifier of the workspace.
last_health_check_at
string
The timestamp when the last health check was performed by Schematics.
location
string
The IBM Cloud location where your workspace was provisioned.
name
string
The name of the workspace.
resource_group
string
The resource group the workspace was provisioned in.
runtime_data
array
Information about the provisioning engine, state file, and runtime logs.
shared_data
SharedTargetDataResponse
Information about the Target used by the templates originating from IBM Cloud catalog offerings. This information is not relevant when you create a workspace from your own Terraform template.
status
string
The status of the workspace.
**Active**: After you successfully ran your infrastructure code by applying your Terraform execution plan, the state of your workspace changes to `Active`.
**Connecting**: Schematics tries to connect to the template in your source repo. If successfully connected, the template is downloaded and metadata, such as input parameters, is extracted. After the template is downloaded, the state of the workspace changes to `Scanning`.
**Draft**: The workspace is created without a reference to a GitHub or GitLab repository.
**Failed**: If errors occur during the execution of your infrastructure code in IBM Cloud Schematics, your workspace status is set to `Failed`.
**Inactive**: The Terraform template was scanned successfully and the workspace creation is complete. You can now start running Schematics plan and apply jobs to provision the IBM Cloud resources that you specified in your template. If you have an `Active` workspace and decide to remove all your resources, your workspace is set to `Inactive` after all your resources are removed.
**In progress**: When you instruct IBM Cloud Schematics to run your infrastructure code by applying your Terraform execution plan, the status of our workspace changes to `In progress`.
**Scanning**: The download of the Terraform template is complete and vulnerability scanning started. If the scan is successful, the workspace state changes to `Inactive`. If errors in your template are found, the state changes to `Template Error`.
**Stopped**: The Schematics plan, apply, or destroy job was cancelled manually.
**Template Error**: The Schematics template contains errors and cannot be processed.
tags
array
A list of tags that are associated with the workspace.
template_data
array
Information about the Terraform or IBM Cloud software template that you want to use.
template_ref
string
Workspace template reference.
template_repo
TemplateRepoResponse
Information about the Template repository used by the workspace
type
array
The Terraform version that was used to run your Terraform code.
updated_at
string
The timestamp when the workspace was last updated.
updated_by
string
The user ID that updated the workspace.
cart_id
string
The associate cart order ID.
project_id
string
The associate project ID.
last_action_name
string
Name of the last Action performed on workspace.
last_activity_id
string
ID of last Activity performed.
last_job
LastJob
Last job details
workspace_status
WorkspaceStatusResponse
Response that indicate the status of the workspace as either frozen or locked.
workspace_status_msg
WorkspaceStatusMessage
Information about the last job that ran against the workspace. -
agent
AgentInfo
Agent name, Agent id and associated policy ID information
settings
array
Input settings to be applied to the workspace, for example, `job_timeout_override`
git_token_ref
string
secrets manager reference to git token
encryption
EncryptionInfo
Encryption details about the workspace such as scheme (byok/kyok) and key CRN.
400 - Bad request - Verify that the information in your request body is complete and correctly formatted in JSON.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - The workspace already exists. To find a list of workspaces, use the `GET /workspaces` API.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - The workspace is frozen and disabled. Unfreeze the workspace first before you retry the request. Or the Schematics create, update, delete action has not completed. Wait until the create, update, delete, plan, apply, destroy or refresh action completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Delete a workspace
DELETE /v1/workspaces/{w_id}
Deletes a workspace from IBM Cloud Schematics. Deleting a workspace does not automatically remove the IBM Cloud resources that the workspace manages. To remove all resources that are associated with the workspace, use the `DELETE /v1/workspaces/{id}?destroy_resources=true` API.
Note: If you delete a workspace without deleting the resources, you must manage your resources with the resource dashboard or CLI afterwards. You cannot use IBM Cloud Schematics anymore to manage your resources.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.delete
Request
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
Query Parameters
destroy_resources
string
If set to `true`, refresh_token header configuration is required to delete all the Terraform resources, and the Schematics workspace. If set to `false`, you can remove only the workspace. Your Terraform resources are still available and must be managed with the resource dashboard or CLI.
Response
200 - Successfully deleted the workspace.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - The workspace is frozen and disabled. Unfreeze the workspace first before you retry the request. Or the Schematics create, update, delete action has not completed. Wait until the create, update, delete, plan, apply, destroy or refresh action completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Get workspace details
GET /v1/workspaces/{w_id}
Retrieve detailed information for a workspace in your IBM Cloud account.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.read
Request
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
Query Parameters
Response
200 - Successfully retrieved details about your workspace.
applied_shareddata_ids
array
List of applied shared dataset ID.
catalog_ref
CatalogRef
Information about the software template that you chose from the IBM Cloud catalog. This information is returned for IBM Cloud catalog offerings only.
created_at
string
The timestamp when the workspace was created.
created_by
string
The user ID that created the workspace.
crn
string
The workspace CRN.
dependencies
Dependencies
Workspace dependencies
description
string
The description of the workspace.
id
string
The unique identifier of the workspace.
last_health_check_at
string
The timestamp when the last health check was performed by Schematics.
location
string
The IBM Cloud location where your workspace was provisioned.
name
string
The name of the workspace.
resource_group
string
The resource group the workspace was provisioned in.
runtime_data
array
Information about the provisioning engine, state file, and runtime logs.
shared_data
SharedTargetDataResponse
Information about the Target used by the templates originating from IBM Cloud catalog offerings. This information is not relevant when you create a workspace from your own Terraform template.
status
string
The status of the workspace.
**Active**: After you successfully ran your infrastructure code by applying your Terraform execution plan, the state of your workspace changes to `Active`.
**Connecting**: Schematics tries to connect to the template in your source repo. If successfully connected, the template is downloaded and metadata, such as input parameters, is extracted. After the template is downloaded, the state of the workspace changes to `Scanning`.
**Draft**: The workspace is created without a reference to a GitHub or GitLab repository.
**Failed**: If errors occur during the execution of your infrastructure code in IBM Cloud Schematics, your workspace status is set to `Failed`.
**Inactive**: The Terraform template was scanned successfully and the workspace creation is complete. You can now start running Schematics plan and apply jobs to provision the IBM Cloud resources that you specified in your template. If you have an `Active` workspace and decide to remove all your resources, your workspace is set to `Inactive` after all your resources are removed.
**In progress**: When you instruct IBM Cloud Schematics to run your infrastructure code by applying your Terraform execution plan, the status of our workspace changes to `In progress`.
**Scanning**: The download of the Terraform template is complete and vulnerability scanning started. If the scan is successful, the workspace state changes to `Inactive`. If errors in your template are found, the state changes to `Template Error`.
**Stopped**: The Schematics plan, apply, or destroy job was cancelled manually.
**Template Error**: The Schematics template contains errors and cannot be processed.
tags
array
A list of tags that are associated with the workspace.
template_data
array
Information about the Terraform or IBM Cloud software template that you want to use.
template_ref
string
Workspace template reference.
template_repo
TemplateRepoResponse
Information about the Template repository used by the workspace
type
array
The Terraform version that was used to run your Terraform code.
updated_at
string
The timestamp when the workspace was last updated.
updated_by
string
The user ID that updated the workspace.
cart_id
string
The associate cart order ID.
project_id
string
The associate project ID.
last_action_name
string
Name of the last Action performed on workspace.
last_activity_id
string
ID of last Activity performed.
last_job
LastJob
Last job details
workspace_status
WorkspaceStatusResponse
Response that indicate the status of the workspace as either frozen or locked.
workspace_status_msg
WorkspaceStatusMessage
Information about the last job that ran against the workspace. -
agent
AgentInfo
Agent name, Agent id and associated policy ID information
settings
array
Input settings to be applied to the workspace, for example, `job_timeout_override`
git_token_ref
string
secrets manager reference to git token
encryption
EncryptionInfo
Encryption details about the workspace such as scheme (byok/kyok) and key CRN.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Update workspace metadata
PATCH /v1/workspaces/{w_id}
Use this API to update the following workspace metadata:
- Workspace name (`name`) - Note: Updating the workspace name does not update the ID of the workspace.
- Workspace description (`description`)
- Tags (`tags[]`)
- Resource group (`resource_group`)
- Workspace status (`workspace_status.frozen`)
Tip: If you want to update information about the Terraform template or IBM Cloud catalog software template that your workspace points to, use the `PUT /v1/workspaces/{id}` API. To update workspace variables, use the `PUT /v1/workspaces/{id}/template_data/{template_id}/values` API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.update
Request
Request Body
WorkspaceUpdateRequest
Input parameters to update workspace metadata.
catalog_ref
CatalogRef
Information about the software template that you chose from the IBM Cloud catalog. This information is returned for IBM Cloud catalog offerings only.
dry_run
boolean
Dry run
owning_account
string
Owning account ID of the catalog.
item_icon_url
string
The URL to the icon of the software template in the IBM Cloud catalog.
item_id
string
The ID of the software template that you chose to install from the IBM Cloud catalog. This software is provisioned with Schematics.
item_name
string
The name of the software that you chose to install from the IBM Cloud catalog.
item_readme_url
string
The URL to the readme file of the software template in the IBM Cloud catalog.
item_url
string
The URL to the software template in the IBM Cloud catalog.
launch_url
string
The URL to the dashboard to access your software.
offering_version
string
The version of the software template that you chose to install from the IBM Cloud catalog.
service_extensions
array
Service Extensions
description
string
The description of the workspace.
dependencies
Dependencies
Workspace dependencies
parents
array
List of workspace parents CRN identifiers
children
array
List of workspace children CRN identifiers
name
string
The name of the workspace.
shared_data
SharedTargetData
Information about the Target used by the templates originating from the IBM Cloud catalog offerings. This information is not relevant for workspace created using your own Terraform template.
cluster_created_on
string
Cluster created on.
cluster_id
string
The ID of the cluster where you want to provision the resources of all IBM Cloud catalog templates that are included in the catalog offering.
cluster_name
string
The cluster name.
cluster_type
string
The cluster type.
entitlement_keys
array
The entitlement key that you want to use to install IBM Cloud entitled software.
namespace
string
The Kubernetes namespace or OpenShift project where the resources of all IBM Cloud catalog templates that are included in the catalog offering are deployed into.
region
string
The IBM Cloud region that you want to use for the resources of all IBM Cloud catalog templates that are included in the catalog offering.
resource_group_id
string
The ID of the resource group that you want to use for the resources of all IBM Cloud catalog templates that are included in the catalog offering.
worker_count
integer
The cluster worker count.
worker_machine_type
string
The cluster worker type.
tags
array
A list of tags that you want to associate with your workspace.
template_data
array
Input data for the Template
template_repo
TemplateRepoUpdateRequest
Input to update the template repository data
branch
string
The repository branch.
release
string
The repository release.
repo_sha_value
string
The repository SHA value.
repo_url
string
The repository URL.
url
string
The source URL.
skip_submodules_checkout
boolean
Set this variable to checkout git sub-modules.
type
array
List of Workspace type.
workspace_status
WorkspaceStatusUpdateRequest
Input to update the workspace status.
frozen
boolean
If set to true, the workspace is frozen and changes to the workspace are disabled.
frozen_at
string
Frozen at
frozen_by
string
Frozen by
locked
boolean
Locked status
locked_by
string
Locked by
locked_time
string
Locked at
workspace_status_msg
WorkspaceStatusMessage
Information about the last job that ran against the workspace. -
status_code
string
The success or error code that was returned for the last plan, apply, or destroy job that ran against your workspace.
status_msg
string
The success or error message that was returned for the last plan, apply, or destroy job that ran against your workspace.
agent_id
string
agent id that process workspace jobs.
settings
array
Input settings to be applied to the workspace, for example, `job_timeout_override`
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
Query Parameters
Response
200 - Successfully updated the workspace metadata.
applied_shareddata_ids
array
List of applied shared dataset ID.
catalog_ref
CatalogRef
Information about the software template that you chose from the IBM Cloud catalog. This information is returned for IBM Cloud catalog offerings only.
created_at
string
The timestamp when the workspace was created.
created_by
string
The user ID that created the workspace.
crn
string
The workspace CRN.
dependencies
Dependencies
Workspace dependencies
description
string
The description of the workspace.
id
string
The unique identifier of the workspace.
last_health_check_at
string
The timestamp when the last health check was performed by Schematics.
location
string
The IBM Cloud location where your workspace was provisioned.
name
string
The name of the workspace.
resource_group
string
The resource group the workspace was provisioned in.
runtime_data
array
Information about the provisioning engine, state file, and runtime logs.
shared_data
SharedTargetDataResponse
Information about the Target used by the templates originating from IBM Cloud catalog offerings. This information is not relevant when you create a workspace from your own Terraform template.
status
string
The status of the workspace.
**Active**: After you successfully ran your infrastructure code by applying your Terraform execution plan, the state of your workspace changes to `Active`.
**Connecting**: Schematics tries to connect to the template in your source repo. If successfully connected, the template is downloaded and metadata, such as input parameters, is extracted. After the template is downloaded, the state of the workspace changes to `Scanning`.
**Draft**: The workspace is created without a reference to a GitHub or GitLab repository.
**Failed**: If errors occur during the execution of your infrastructure code in IBM Cloud Schematics, your workspace status is set to `Failed`.
**Inactive**: The Terraform template was scanned successfully and the workspace creation is complete. You can now start running Schematics plan and apply jobs to provision the IBM Cloud resources that you specified in your template. If you have an `Active` workspace and decide to remove all your resources, your workspace is set to `Inactive` after all your resources are removed.
**In progress**: When you instruct IBM Cloud Schematics to run your infrastructure code by applying your Terraform execution plan, the status of our workspace changes to `In progress`.
**Scanning**: The download of the Terraform template is complete and vulnerability scanning started. If the scan is successful, the workspace state changes to `Inactive`. If errors in your template are found, the state changes to `Template Error`.
**Stopped**: The Schematics plan, apply, or destroy job was cancelled manually.
**Template Error**: The Schematics template contains errors and cannot be processed.
tags
array
A list of tags that are associated with the workspace.
template_data
array
Information about the Terraform or IBM Cloud software template that you want to use.
template_ref
string
Workspace template reference.
template_repo
TemplateRepoResponse
Information about the Template repository used by the workspace
type
array
The Terraform version that was used to run your Terraform code.
updated_at
string
The timestamp when the workspace was last updated.
updated_by
string
The user ID that updated the workspace.
cart_id
string
The associate cart order ID.
project_id
string
The associate project ID.
last_action_name
string
Name of the last Action performed on workspace.
last_activity_id
string
ID of last Activity performed.
last_job
LastJob
Last job details
workspace_status
WorkspaceStatusResponse
Response that indicate the status of the workspace as either frozen or locked.
workspace_status_msg
WorkspaceStatusMessage
Information about the last job that ran against the workspace. -
agent
AgentInfo
Agent name, Agent id and associated policy ID information
settings
array
Input settings to be applied to the workspace, for example, `job_timeout_override`
git_token_ref
string
secrets manager reference to git token
encryption
EncryptionInfo
Encryption details about the workspace such as scheme (byok/kyok) and key CRN.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - The workspace is frozen and disabled. Unfreeze the workspace first before you retry the request. Or the Schematics create, update, delete action has not completed. Wait until the create, update, delete, plan, apply, destroy or refresh action completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Update workspace
PUT /v1/workspaces/{w_id}
Use this API to update or replace the entire workspace, including the Terraform template (`template_repo`) or IBM Cloud catalog software template (`catalog_ref`) that your workspace points to.
Tip:- If you want to update workspace metadata, use the `PATCH /v1/workspaces/{id}` API. To update workspace variables, use the `PUT /v1/workspaces/{id}/template_data/{template_id}/values` API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.update
Request
Request Body
WorkspaceUpdateRequest
Replace the Workspace definition.
catalog_ref
CatalogRef
Information about the software template that you chose from the IBM Cloud catalog. This information is returned for IBM Cloud catalog offerings only.
dry_run
boolean
Dry run
owning_account
string
Owning account ID of the catalog.
item_icon_url
string
The URL to the icon of the software template in the IBM Cloud catalog.
item_id
string
The ID of the software template that you chose to install from the IBM Cloud catalog. This software is provisioned with Schematics.
item_name
string
The name of the software that you chose to install from the IBM Cloud catalog.
item_readme_url
string
The URL to the readme file of the software template in the IBM Cloud catalog.
item_url
string
The URL to the software template in the IBM Cloud catalog.
launch_url
string
The URL to the dashboard to access your software.
offering_version
string
The version of the software template that you chose to install from the IBM Cloud catalog.
service_extensions
array
Service Extensions
description
string
The description of the workspace.
dependencies
Dependencies
Workspace dependencies
parents
array
List of workspace parents CRN identifiers
children
array
List of workspace children CRN identifiers
name
string
The name of the workspace.
shared_data
SharedTargetData
Information about the Target used by the templates originating from the IBM Cloud catalog offerings. This information is not relevant for workspace created using your own Terraform template.
cluster_created_on
string
Cluster created on.
cluster_id
string
The ID of the cluster where you want to provision the resources of all IBM Cloud catalog templates that are included in the catalog offering.
cluster_name
string
The cluster name.
cluster_type
string
The cluster type.
entitlement_keys
array
The entitlement key that you want to use to install IBM Cloud entitled software.
namespace
string
The Kubernetes namespace or OpenShift project where the resources of all IBM Cloud catalog templates that are included in the catalog offering are deployed into.
region
string
The IBM Cloud region that you want to use for the resources of all IBM Cloud catalog templates that are included in the catalog offering.
resource_group_id
string
The ID of the resource group that you want to use for the resources of all IBM Cloud catalog templates that are included in the catalog offering.
worker_count
integer
The cluster worker count.
worker_machine_type
string
The cluster worker type.
tags
array
A list of tags that you want to associate with your workspace.
template_data
array
Input data for the Template
template_repo
TemplateRepoUpdateRequest
Input to update the template repository data
branch
string
The repository branch.
release
string
The repository release.
repo_sha_value
string
The repository SHA value.
repo_url
string
The repository URL.
url
string
The source URL.
skip_submodules_checkout
boolean
Set this variable to checkout git sub-modules.
type
array
List of Workspace type.
workspace_status
WorkspaceStatusUpdateRequest
Input to update the workspace status.
frozen
boolean
If set to true, the workspace is frozen and changes to the workspace are disabled.
frozen_at
string
Frozen at
frozen_by
string
Frozen by
locked
boolean
Locked status
locked_by
string
Locked by
locked_time
string
Locked at
workspace_status_msg
WorkspaceStatusMessage
Information about the last job that ran against the workspace. -
status_code
string
The success or error code that was returned for the last plan, apply, or destroy job that ran against your workspace.
status_msg
string
The success or error message that was returned for the last plan, apply, or destroy job that ran against your workspace.
agent_id
string
agent id that process workspace jobs.
settings
array
Input settings to be applied to the workspace, for example, `job_timeout_override`
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
Query Parameters
Response
200 - Successfully updated the workspace metadata.
applied_shareddata_ids
array
List of applied shared dataset ID.
catalog_ref
CatalogRef
Information about the software template that you chose from the IBM Cloud catalog. This information is returned for IBM Cloud catalog offerings only.
created_at
string
The timestamp when the workspace was created.
created_by
string
The user ID that created the workspace.
crn
string
The workspace CRN.
dependencies
Dependencies
Workspace dependencies
description
string
The description of the workspace.
id
string
The unique identifier of the workspace.
last_health_check_at
string
The timestamp when the last health check was performed by Schematics.
location
string
The IBM Cloud location where your workspace was provisioned.
name
string
The name of the workspace.
resource_group
string
The resource group the workspace was provisioned in.
runtime_data
array
Information about the provisioning engine, state file, and runtime logs.
shared_data
SharedTargetDataResponse
Information about the Target used by the templates originating from IBM Cloud catalog offerings. This information is not relevant when you create a workspace from your own Terraform template.
status
string
The status of the workspace.
**Active**: After you successfully ran your infrastructure code by applying your Terraform execution plan, the state of your workspace changes to `Active`.
**Connecting**: Schematics tries to connect to the template in your source repo. If successfully connected, the template is downloaded and metadata, such as input parameters, is extracted. After the template is downloaded, the state of the workspace changes to `Scanning`.
**Draft**: The workspace is created without a reference to a GitHub or GitLab repository.
**Failed**: If errors occur during the execution of your infrastructure code in IBM Cloud Schematics, your workspace status is set to `Failed`.
**Inactive**: The Terraform template was scanned successfully and the workspace creation is complete. You can now start running Schematics plan and apply jobs to provision the IBM Cloud resources that you specified in your template. If you have an `Active` workspace and decide to remove all your resources, your workspace is set to `Inactive` after all your resources are removed.
**In progress**: When you instruct IBM Cloud Schematics to run your infrastructure code by applying your Terraform execution plan, the status of our workspace changes to `In progress`.
**Scanning**: The download of the Terraform template is complete and vulnerability scanning started. If the scan is successful, the workspace state changes to `Inactive`. If errors in your template are found, the state changes to `Template Error`.
**Stopped**: The Schematics plan, apply, or destroy job was cancelled manually.
**Template Error**: The Schematics template contains errors and cannot be processed.
tags
array
A list of tags that are associated with the workspace.
template_data
array
Information about the Terraform or IBM Cloud software template that you want to use.
template_ref
string
Workspace template reference.
template_repo
TemplateRepoResponse
Information about the Template repository used by the workspace
type
array
The Terraform version that was used to run your Terraform code.
updated_at
string
The timestamp when the workspace was last updated.
updated_by
string
The user ID that updated the workspace.
cart_id
string
The associate cart order ID.
project_id
string
The associate project ID.
last_action_name
string
Name of the last Action performed on workspace.
last_activity_id
string
ID of last Activity performed.
last_job
LastJob
Last job details
workspace_status
WorkspaceStatusResponse
Response that indicate the status of the workspace as either frozen or locked.
workspace_status_msg
WorkspaceStatusMessage
Information about the last job that ran against the workspace. -
agent
AgentInfo
Agent name, Agent id and associated policy ID information
settings
array
Input settings to be applied to the workspace, for example, `job_timeout_override`
git_token_ref
string
secrets manager reference to git token
encryption
EncryptionInfo
Encryption details about the workspace such as scheme (byok/kyok) and key CRN.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - The workspace is frozen and disabled. Unfreeze the workspace first before you retry the request. Or the Schematics create, update, delete action has not completed. Wait until the create, update, delete, plan, apply, destroy or refresh action completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Show workspace template readme
GET /v1/workspaces/{w_id}/templates/readme
Retrieve the `README.md` file of the Terraform of IBM Cloud catalog template that your workspace points to.
Request
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
Query Parameters
ref
string
The GitHub or GitLab branch where the `README.md` file is stored, or the commit ID or tag that references the `README.md` file that you want to retrieve. If you do not specify this option, the `README.md` file is retrieved from the master branch by default.
formatted
string
The format of the readme file. Value ''markdown'' will give markdown, otherwise html
Response
200 - Successfully retrieved the README.md of the template that your workspace points to.
readme
string
The `README.md` file for the template used by the workspace
400 - Bad request - Verify that the information in your request body is complete and correctly formatted in JSON.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - The specified resource was not found
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Upload a TAR file to your workspace
PUT /v1/workspaces/{w_id}/template_data/{t_id}/template_repo_upload
Provide your Terraform template by uploading a TAR file from your local machine. Before you use this API, you must create a workspace without a link to a GitHub or GitLab repository with the `POST /v1/workspaces` API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.update
Request
Request Body
Upload template tar file
Path Parameters
w_id
Required *
string
The ID of the workspace where you want to upload your `.tar` file. To find the workspace ID, use the `GET /v1/workspaces` API.
t_id
Required *
string
The ID of the Terraform template in your workspace. When you create a workspace, a unique ID is assigned to your Terraform template, even if no template was provided during workspace creation. To find this ID, use the `GET /v1/workspaces` API and review the `template_data.id` value.
Query Parameters
Response
200 - Successfully uploaded the TAR file to your workspace.
file_value
string
Tar file value.
has_received_file
boolean
Has received tar file?
id
string
Template ID
400 - Bad request - Verify that the information in your request body is complete and correctly formatted in JSON.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
List workspace jobs
GET /v1/workspaces/{w_id}/actions
Retrieve a list of all jobs that ran against a workspace. Jobs are generated when you use the `apply`, `plan`, `destroy`, and `refresh`, command API.
Request
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
Query Parameters
offset
integer
The starting position of the item in the list of items. For example, if you have three workspaces in your account, the first workspace is assigned position number 0, the second workspace is assigned position number 1, and so forth. If you have 6 workspaces and you want to list the details for workspaces `2-6`, enter 1. To limit the number of workspaces that is returned, use the `limit` option in addition to the `offset` option. Negative numbers are not supported and are ignored.
limit
integer
The maximum number of items that you want to list. The number must be a positive integer between 1 and 2000. If no value is provided, 100 is used by default.
Response
200 - Successfully retrieved list of workspace jobs.
actions
array
List of workspace jobs
workspace_id
string
The ID of the workspace.
workspace_name
string
The name of the workspace.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Stop the workspace job
DELETE /v1/workspaces/{w_id}/actions/{activity_id}
Stop an ongoing schematics job that runs against your workspace. Note: If you remove the Schematics apply job that runs against your workspace, any changes to your IBM Cloud resources that are already applied are not reverted. If a creation, update, or deletion is currently in progress, Schematics waits for the job to be completed first. Then, any other resource creations, updates, or deletions that are included in your Terraform template file are ignored. <h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Request
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
activity_id
Required *
string
The ID of the activity or job, for which you want to retrieve details. To find the job ID, use the `GET /v1/workspaces/{id}/actions` API.
Query Parameters
Response
202 - Successfully initiated the stopping of workspace job.
activityid
string
The ID of the activity or job that was created when you initiated a request to `apply` a Terraform template. You can use the ID to retrieve log file by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
400 - The specified action cannot be stopped because the job completed successfully or a user in the account already requested to stop this action. Use the `GET /v1/workspace/{id}/actions` API to find the details for your job.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The requested workspace or job cannot be located. Check that you have the correct workspace ID and job IDs in your request.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - The specified resource is marked as frozen. Unfreeze the resource before you retry the request.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Get workspace job details
GET /v1/workspaces/{w_id}/actions/{activity_id}
Get the details for a workspace job that ran against the workspace. This API returns the job status and a URL to the log file that you can retrieve by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
Request
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
activity_id
Required *
string
The ID of the activity or job, for which you want to retrieve details. To find the job ID, use the `GET /v1/workspaces/{id}/actions` API.
Query Parameters
Response
200 - Successfully retrieved the workspace jobs details.
action_id
string
The ID of the activity or job. You can use the ID to retrieve the logs for that job by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
message
array
Information about the success or failure of your job, including a success or error code and the timestamp when the job succeeded or failed.
name
string
The type of actovoty or job that ran against your workspace.
- APPLY: The apply job was created when you used the `PUT /v1/workspaces/{id}/apply` API to apply a Terraform template in IBM Cloud.
- DESTROY: The destroy job was created when you used the `DELETE /v1/workspaces/{id}/destroy` API to remove all resources that are associated with your workspace.
- PLAN: The plan job was created when you used the `POST /v1/workspaces/{id}/plan` API to create a Terraform execution plan.
performed_at
string
The timestamp when the job was initiated.
performed_by
string
The user ID who initiated the job.
status
string
The status of your activity or job. To retrieve the URL to your job logs, use the GET /v1/workspaces/{id}/actions/{action_id}/logs API.
- COMPLETED: The job completed successfully.
- CREATED: The job was created, but the provisioning, modification, or removal of IBM Cloud resources has not started yet.
- FAILED: An error occurred during the plan, apply, or destroy job. Use the job ID to retrieve the URL to the log files for your job.
- IN PROGRESS: The job is in progress. You can use the log_url to access the logs.
templates
array
List of template activities
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The requested workspace or job cannot be located. Check that you have the correct workspace ID and job IDs in your request.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Run Terraform Commands
PUT /v1/workspaces/{w_id}/commands
Run Terraform state commands to modify the workspace state file, by using the IBM Cloud Schematics API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Request
Request Body
TerraformCommands
command value
commands
array
List of commands. You can execute single set of commands or multiple commands. For more information, about the payload of the multiple commands, refer to Commands.
operation_name
string
Command name
description
string
Command description
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
Query Parameters
Response
200 - Successfully updated the workspace metadata.
activityid
string
The ID of the job that was created when you initiated a request to `apply` a Terraform template. You can use the ID to retrieve log file by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - Workspace Command failed. The workspace is marked as frozen. Unfreeze the workspace before you retry the request.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
to determine what resources exist in your IBM Cloud account.
Note: This API returns an activity or job ID that you use to retrieve the
log URL with the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
Important: Applying a template might incur costs. Make sure to review the pricing information for the resources that you specified in your templates before you apply the template in IBM Cloud. To find a summary of job that Schematics is about to perform, create a Terraform execution plan with the `POST /v1/workspaces/{id}/plan` API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.">
Perform a Schematics `apply` job
PUT /v1/workspaces/{w_id}/apply
Run a Schematics `apply` job against your workspace. An `apply` job provisions, modifies, or removes the IBM Cloud resources that you described in the Terraform template that your workspace points to. Depending on the type and number of resources that you want to provision or modify, this process might take a few minutes, or even up to hours to complete. During this time, you cannot make changes to your workspace. After all updates are applied, the state of the files is persisted to determine what resources exist in your IBM Cloud account.
Important: Your workspace must be in an `Inactive`, `Active`, `Failed`, or `Stopped` state to perform a Schematics `apply` job. After all updates are applied, the state of the files is persisted
to determine what resources exist in your IBM Cloud account.
Note: This API returns an activity or job ID that you use to retrieve the
log URL with the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
Important: Applying a template might incur costs. Make sure to review the pricing information for the resources that you specified in your templates before you apply the template in IBM Cloud. To find a summary of job that Schematics is about to perform, create a Terraform execution plan with the `POST /v1/workspaces/{id}/plan` API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace-resources.create
Request
Request Body
WorkspaceActivityOptions
Workspace 'apply' job options
action_options
WorkspaceActivityOptionsTemplate
Workspace job options template
target
array
A list of Terraform resources to target.
tf_vars
array
Terraform variables for the workspace job options.
Path Parameters
w_id
Required *
string
The ID of the workspace for which you want to run a Schematics `apply` job. To find the workspace ID, use the `GET /workspaces` API.
Query Parameters
Response
202 - Successfully ran a Schematics `apply` job against your workspace.
activityid
string
The ID of the activity or job that was created when you initiated a request to `apply` a Terraform template. You can use the ID to retrieve log file by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - Apply failed. Could not perform an `apply` job against the workspace. The workspace is frozen, or a Schematics create, update, `plan`, `apply`, `destroy`, delete, or `refresh` job has not completed yet. Unfreeze the workspace first or wait until the create, update, `plan`, `apply`, `destroy`, delete, or `refresh` job completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Perform a Schematics `destroy` job
PUT /v1/workspaces/{w_id}/destroy
Run a Schematics `destroy` job against your workspace. A `destroy` job removes all IBM Cloud resources that are associated with your workspace. Removing your resources does not delete the Schematics workspace. To delete the workspace, use the `DELETE /v1/workspaces/{id}` API. This API returns an activity or job ID that you use to retrieve the URL to the log file with the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
Important: Your workspace must be in an `Active`, `Failed`, or `Stopped` state to perform a Schematics `destroy` job.
Note: Deleting IBM Cloud resources cannot be undone. Make sure that you back up any required data before you remove your resources.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace-resources.delete
Request
Request Body
WorkspaceActivityOptions
Workspace destroy command options
action_options
WorkspaceActivityOptionsTemplate
Workspace job options template
target
array
A list of Terraform resources to target.
tf_vars
array
Terraform variables for the workspace job options.
Path Parameters
w_id
Required *
string
The ID of the workspace for which you want to perform a Schematics `destroy` job. To find the workspace ID, use the `GET /workspaces` API.
Query Parameters
Response
202 - Successfully initiated a Schematics `destroy` job against your workspace.
activityid
string
The ID of the activity or job that was created when you initiated a request to `destroy` a Terraform template. You can use the ID to retrieve log file by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The requested workspace cannot be located. Check that you have the correct workspace ID in your request. Or the requested state-file cannot be located. Run apply action to create a state-file.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - Could not perform a `destroy` job against the workspace. The workspace is frozen, or a Schematics create, update, `plan`, `apply`, delete, `destroy`, or `refresh` job has not completed yet. Unfreeze the workspace first or wait until the create, update, `plan`, `apply`, delete, `destroy`, or `refresh` job completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
429 - Too many requests have been made within a time window. "IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region". Wait before calling the API again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Perform a Schematics `plan` job
POST /v1/workspaces/{w_id}/plan
Run a Schematics `plan` job against your workspace. The `plan` job creates a summary of IBM Cloud resources that must be created, modified, or deleted to achieve the state that is described in the Terraform or IBM Cloud catalog template that your workspace points to. During this time, you cannot make changes to your workspace. You can use the summary to verify your changes before you apply the template in IBM Cloud.
Important: Your workspace must be in an `Inactive`, `Active`, `Failed`, or `Stopped` state to perform a Schematics `plan` job.
Note: This API returns an activity or job ID that you use to retrieve the URL to the log file with the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace-resources.plan
Request
Request Body
WorkspaceActivityOptions
Workspace 'plan' job options
action_options
WorkspaceActivityOptionsTemplate
Workspace job options template
target
array
A list of Terraform resources to target.
tf_vars
array
Terraform variables for the workspace job options.
Path Parameters
w_id
Required *
string
The ID of the workspace, for which you want to run a Schematics `plan` job. To find the ID of your workspace, use the `GET /v1/workspaces` API.
Query Parameters
Response
202 - Successfully performed a Schematics `plan` job.
activityid
string
The ID of the activity or job that was created when you initiated a request to `plan` a Terraform template. You can use the ID to retrieve log file by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
400 - Bad request - Verify that the information in your request body is complete and correctly formatted in JSON.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - The workspace is frozen and disabled. Unfreeze the workspace first before you retry the request. Or the Schematics create, update, delete action has not completed. Wait until the create, update, delete, plan, apply, destroy or refresh action completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
503 - IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Perform a Schematics `refresh` job
PUT /v1/workspaces/{w_id}/refresh
Run a Schematics `refresh` job against your workspace. A `refresh` job validates the IBM Cloud resources in your account against the state that is stored in the Terraform statefile of your workspace. If differences are found, the Terraform statefile is updated accordingly. This API returns an activity or job ID that you use to retrieve the URL to the log file with the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.refresh
Request
Path Parameters
w_id
Required *
string
The ID of the workspace, for which you want to run a Schematics `refresh` job. To find the ID of your workspace, use the `GET /v1/workspaces` API.
Query Parameters
Response
202 - Successfully initiated a Schematics `refresh` job against your workspace.
activityid
string
The ID of the activity or job that was created for your workspace `refresh` activity or job. You can use the ID to retrieve the log file by using the `GET /v1/workspaces/{id}/actions/{action_id}/logs` API.
400 - Bad request - Verify that the information in your request body is complete and correctly formatted in JSON.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
409 - Could not perform a `refresh` job against the workspace. The workspace is frozen, or a Schematics create, update, `plan`, `apply`, delete, `destroy`, or `refresh` job has not completed yet. Unfreeze the workspace first or wait until the create, update, `plan`, `apply`, delete, `destroy`, or `refresh` job completes before you try again.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
List workspace input variables
GET /v1/workspaces/{w_id}/template_data/{t_id}/values
Retrieve a list of input variables that are declared in your Terraform or IBM Cloud catalog template.
<h3>Authorization</h3>
Schematics support generic authorization for its resources. For more information, about Schematics access and permissions, see Schematics service access roles and required permissions.
Auditing
Calling this method generates the following auditing event.
schematics.workspace.template_values
Request
Path Parameters
w_id
Required *
string
The ID of the workspace. To find the workspace ID, use the `GET /v1/workspaces` API.
t_id
Required *
string
The ID of the Terraform template in your workspace. When you create a workspace, the Terraform template that your workspace points to is assigned a unique ID. Use the `GET /v1/workspaces` to look up the workspace IDs and template IDs or `template_data.id` in your IBM Cloud account.
Query Parameters
Response
200 - Successfully retrieved a list of input variables that are declared in your template.
values_metadata
array
Information about workspace variable metadata.
401 - The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
403 - Unauthorized access. Check that you have the correct access credentials and permissions.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
404 - Not found. The requested workspace cannot be located. Check that you have the correct workspace ID in your request. Or the requested workspace/template could not be located. Check that you have the correct template ID in your request.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
500 - Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact IBM Cloud support.
message
string
Message text
message_id
string
The message ID for translation.
request_id
string
The request ID for request tracking.
status_code
integer
The API response code.
timestamp
string
The API response timestamp.
Replace workspace input variables
PUT /v1/workspaces/{w_id}/template_data/{t_id}/values
[...]
